- [HTTP request](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#body.request_body)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#body.response_body)
- [ReferenceNumberPaidNotificationResponse](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResponse)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResponse.SCHEMA_REPRESENTATION)
- [ReferenceNumberPaidNotificationResult](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResult)
  - [JSON representation](https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResult.SCHEMA_REPRESENTATION)

Notify Google that a customer completed payment of a reference number.

It is expected that this will be called within milliseconds of the user paying. While this call can be enqueued if the network is down, Google expects the user will typically receive notification that their payment has been paid by the time they are leaving the store.

If the endpoint encounters an error while processing the request, the endpoint will return HTTP 4xx or 5xx and the HTTP body will either be of type [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse) or contain a generic error (e.g. a message similar to "There was an error. Please try again later.").

The generic error is used in situations where an [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse) with a clear description could be used to help an attacker understand the payment integrator account identifier of other integrators. In these situations, where either the signing key doesn't match, the payment integrator identifier was not found, or the encryption key was unknown, this method will return a generic error. If the request signature could be verified, additional information regarding the error will be returned in an [`ErrorResponse`](https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse).

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 2
        },
        "requestId": "cmVxdWVzdDE",
        "requestTimestamp": {
          "epochMillis": "1481899949606"
        },
        "paymentIntegratorAccountId": "InvisiCashUSA_USD"
      },
      "paymentIntegratorTransactionId": "abc-e34-21343",
      "generateReferenceNumberRequestId": "aW50ZWdyYXRvciB0cmFuc2FjdGlvbiBpZA",
      "paymentTimestamp": {
        "epochMillis": "1481855969203"
      }
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": {
          "epochMillis": "1481907920760"
        }
      },
      "result": {
        "success": {}
      }
    }

### HTTP request

`POST https://vgw.googleapis.com/gsp/refundable-one-time-payment-code-v2/referenceNumberPaidNotification/https://developers.google.com/pay/refundable-one-time-payment-code-v2/reference/glossary#payment_integrator_account_id`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/RequestHeader) }, "paymentIntegratorTransactionId": string, "generateReferenceNumberRequestId": string, "paymentTimestamp": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Timestamp) } } ``` |

| Fields ||
|---|---|
| `requestHeader` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/RequestHeader)` **REQUIRED**: Common header for all requests. |
| `paymentIntegratorTransactionId` | `string` **OPTIONAL**: This identifier is specific to the integrator and is generated by the integrator. This is the identifier by which the integrator knows this transaction. For convenience, this identifier is included when the payment integrator requests remittanceStatementDetails. |
| `generateReferenceNumberRequestId` | `string` **REQUIRED** : `requestId` of the `generateReferenceNumber` call for this transaction. |
| `paymentTimestamp` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Timestamp)` **REQUIRED**: Timestamp recorded by the integrator when the user paid this reference number. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/refundable-one-time-payment-code-v2/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResponse`)`` |
| HTTP 4XX / 5XX Status | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ErrorResponse)` |
| End of mutually exclusive fields. ||

## ReferenceNumberPaidNotificationResponse

Response object for the `referenceNumberPaidNotification` method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ResponseHeader) }, "result": { object (`https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResult`) }, "googlePaymentTransactionId": string } ``` |

| Fields ||
|---|---|
| `responseHeader` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/ResponseHeader)` **REQUIRED**: Common header for all responses. |
| `result` | ``object (`https://developers.google.com/pay/refundable-one-time-payment-code-v2/google-refundable-one-time-payment-code-api/referenceNumberPaidNotification#ReferenceNumberPaidNotificationResult`)`` **REQUIRED** : Result of this `referenceNumberPaidNotification` call. |
| `googlePaymentTransactionId` | `string` **OPTIONAL** : Populated if `result` is `SUCCESS`, otherwise not populated. A Google-generated identifier for this transaction that is included when the payment integrator requests `remittanceStatementDetails`. |

## ReferenceNumberPaidNotificationResult

Result of this `referenceNumberPaidNotification` call.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "success": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Empty) }, "invalidReferenceNumber": { object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Empty) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED** : Result of this `referenceNumberPaidNotification` call. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `success` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Empty)` The reference number was successfully recorded as paid. |
| `invalidReferenceNumber` | `object (https://developers.google.com/pay/refundable-one-time-payment-code-v2/payment-integrator-refundable-one-time-payment-code-api/Empty)` The reference number was not found. |
| End of mutually exclusive fields. ||